=== cpp/tests/utility/CMakeLists.txt ===
target_sources(tests PRIVATE
    Download.cpp
    Extract.cpp
    Eigen.cpp
    FileSystem.cpp
    Helper.cpp
    IJsonConvertible.cpp
    ISAInfo.cpp
    Logging.cpp
    Preprocessor.cpp
    ProgressBar.cpp
    Timer.cpp
)

if (BUILD_ISPC_MODULE)
    target_sources(tests PRIVATE
        Helper.ispc
    )
endif()
