=== debian/changelog ===
open3d (0.15.1+ds-4build1) kinetic; urgency=medium

  * No-change rebuild against libfmt9

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 21 Aug 2022 06:06:22 +0000

open3d (0.15.1+ds-4) unstable; urgency=medium

  [ Stephan Lachnit ]
  * zmq.hpp now in cppzmq-dev

  [ Timo Röhling ]
  * Improve reproducibility for Sphinx documentation build
  * Enable multithreading for LTO

 -- Timo Röhling <roehling@debian.org>  Wed, 17 Aug 2022 10:14:28 +0200

open3d (0.15.1+ds-3) unstable; urgency=medium

  * Fix FTBFS with fmtlib (Closes: #1014676)
  * Install Python open3d CLI
  * Bump Standards-Version to 4.6.1

 -- Timo Röhling <roehling@debian.org>  Sun, 10 Jul 2022 22:52:35 +0200

open3d (0.15.1+ds-2) unstable; urgency=medium

  * Upload to unstable
    - No transition required, because there are no reverse depends
  * Fix doc-base registration
  * Explicitly link against OpenSSL::Crypto

 -- Timo Röhling <roehling@debian.org>  Thu, 10 Mar 2022 23:21:05 +0100

open3d (0.15.1+ds-1) experimental; urgency=medium

  [ Jochen Sprickerhof ]
  * Add missing build dependency on libimgui-dev

  [ Timo Röhling ]
  * Fix Suggests: open3d-gui
  * New upstream version 0.15.1+ds
  * Drop patches which were applied upstream
  * Bump SONAME to 0.15

 -- Timo Röhling <roehling@debian.org>  Mon, 07 Mar 2022 19:47:06 +0100
