=== debian/control ===
Source: open3d
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Timo Röhling <roehling@debian.org>, Jochen Sprickerhof <jspricke@debian.org>
Build-Depends: debhelper-compat (= 13),
    cmake,
    dh-sequence-numpy3,
    dh-sequence-python3,
    doxygen <!nodoc>,
    libassimp-dev,
    libblas-dev,
    libcurl4-openssl-dev,
    libeigen3-dev,
    libfilament-dev,
    libfilament-tools,
    libflann-dev,
    libfmt-dev (>= 5),
    libglew-dev,
    libglfw3-dev,
    libgmock-dev,
    libimgui-dev,
    libjpeg-dev,
    libjsoncpp-dev,
    liblapack-dev,
    liblapacke-dev,
    liblzf-dev,
    libminizip-dev,
    libmsgpack-dev,
    libnanoflann-dev,
    libpng-dev,
#    libprotobuf-dev,
    libqhull-dev (>= 2019.1),
    libtbb-dev,
    libssl-dev,
    libtinygltf-dev,
    libtinyobjloader-dev,
#    libtorch-dev,
    libxrandr-dev,
    cppzmq-dev,
    pybind11-dev (>= 2.2),
    python3-dev,
    python3-numpy,
    python3-pip,
#    python3-torch,
    python3-setuptools,
    python3-sphinx <!nodoc>,
    python3-sphinx-rtd-theme <!nodoc>,
Build-Depends-Indep:
    pandoc <!nodoc>,
    dh-sequence-sphinxdoc <!nodoc>,
Homepage: http://www.open3d.org
Standards-Version: 4.6.1
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/science-team/open3d.git
Vcs-Browser: https://salsa.debian.org/science-team/open3d
Description: Library for 3D data processing
 Open3D is an open-source library that supports rapid development of
 software that deals with 3D data. The Open3D frontend exposes a set
 of carefully selected data structures and algorithms in both C++ and
 Python. The backend is highly optimized and is set up for parallelization.

Package: libopen3d0.15
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ${source:Synopsis}
 ${source:Extended-Description}

Package: libopen3d-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libopen3d0.15 (= ${binary:Version}),
         libeigen3-dev, libfmt-dev, libglew-dev, libglfw3-dev,
         ${misc:Depends}
Suggests: open3d-doc, open3d-gui, open3d-tools
Description: ${source:Synopsis} - development headers
 ${source:Extended-Description}
 .
 This package contains the development headers for C++

Package: python3-open3d
Section: python
Architecture: any
Provides: ${python3:Provides}
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends},
         open3d-gui-data (= ${source:Version})
Suggests: open3d-doc, open3d-tools
Description: ${source:Synopsis} - Python 3 bindings
 ${source:Extended-Description}
 .
 This package provides the Python 3 bindings for Open3D.

Package: open3d-tools
Section: science
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
Description: ${source:Synopsis} - tools
 ${source:Extended-Description}
 .
 This package provides additional tools for data processing.

Package: open3d-gui
Section: science
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
         open3d-gui-data (= ${source:Version})
Description: ${source:Synopsis} - GUI
 ${source:Extended-Description}
 .
 This package provides the stand-alone GUI for data visualization.

Package: open3d-gui-data
Section: science
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, fonts-roboto
Description: ${source:Synopsis} - GUI resources
 ${source:Extended-Description}
 .
 This package provides the resources for the GUI.

Package: open3d-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${sphinxdoc:Depends}, ${misc:Depends}
Description: ${source:Synopsis} - API documentation
 ${source:Extended-Description}
 .
 This package provides the API documentation.
