=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v(\d\S+)\.tar\.gz/Open3D-$1\.tar\.gz/,\
     dversionmangle=s/\+(?:dfsg|ds)\d*$//,oversionmangle=s/$/+ds/,\
     repack \
https://github.com/intel-isl/Open3D/releases/latest .*/v(\d\S+)\.tar\.gz

opts=mode=git,component=PoissonRecon,repack \
https://github.com/intel-isl/Open3D-PoissonRecon HEAD ignore
